package pl.edu.mimuw.cloudatlas.service.interpreter.interpreter.query.Absyn; // Java Package generated by the BNF Converter.

public class StatementC extends Statement {
    public final ListSelItem listselitem_;

    public final Where where_;

    public final OrderBy orderby_;

    public StatementC(ListSelItem p1, Where p2, OrderBy p3) {

        listselitem_ = p1;
        where_ = p2;
        orderby_ = p3;
    }

    public <R, A> R accept(pl.edu.mimuw.cloudatlas.service.interpreter.interpreter.query.Absyn.Statement.Visitor<R, A> v, A arg) {

        return v.visit(this, arg);
    }

    public int hashCode() {

        return 37 * (37 * (this.listselitem_.hashCode()) + this.where_.hashCode()) + this.orderby_.hashCode();
    }

    public boolean equals(Object o) {

        if (this == o) return true;
        if (o instanceof pl.edu.mimuw.cloudatlas.service.interpreter.interpreter.query.Absyn.StatementC) {
            pl.edu.mimuw.cloudatlas.service.interpreter.interpreter.query.Absyn.StatementC x = (pl.edu.mimuw.cloudatlas.service.interpreter.interpreter.query.Absyn.StatementC) o;
            return this.listselitem_.equals(x.listselitem_) && this.where_.equals(x.where_) && this.orderby_.equals(x.orderby_);
        }
        return false;
    }


}
